; These drive the bomber

Bomber_Score	equ 50			; Score for bomber

Bomber_Hits	equ 4			; Hit counts
Bomb_Hits	equ 40			; Lots
Bomb_Spread	equ 16			; Width of kill area
Bomb_Damage	equ 15			; Damage to ship's shields

; Add one thing to the list

Create_1_Bomber:call Get_Free		; DI := ptr to free space
		jc C1BR_Fail		; Failed

		; Now create a thing

		call Create_Bomber	; Do it

		; Done, exit

C1BR_Fail:	ret			; Done

; Generate a bomber

Create_Bomber:	mov al,cs:optBomb_Cnt	; This many
		mov cs:dTemp1[di],al	;

		mov b cs:dSpeed[di],1	; Frame-rate
		mov b cs:dDelay[di],1	; Start immediately

		; Setup its shape

		mov b cs:dShape[di],20	; Thing sprite

		; Setup colours

		mov ax,0B01h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0201h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],B_Green ; Colour in map

		; Setup the bomb timer

		mov al,cs:optBomb_Rate	; Rate
		mov ah,0		;
		mov cs:dLife[di],ax	;

		; Setup it's hit points

		mov b cs:dHits[di],Bomber_Hits ; This many

		; Setup it's shot routine

		mov w cs:dpShot[di],o Thing_Shot; Shot routine

		; Random speed

		call Rand_32		; Random
		and al,03h		; 0 .. 3
		sub al,2		; -2 .. 1
		jnz CB_1		; Skip if NZ

		mov al,2		; -2 .. 2 not 0

CB_1:		mov cs:ddX[di],al	; Velocity
		mov b cs:ddY[di],0	;

		; Position

		call Rand_X		; Giz a random X

		; Get its Y

		push ds			; Save
		push ax			;

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov dl,ds:[bx]		; Get the Y
		sub dl,5		; In the middle of the man

		pop ax			; Restore
		pop ds			;

		; Setup it's move routine

		mov cx,o Move_Bomber	; Move routine

		; Setup it's implode

		mov bx,o Frag_Implode	; Implosion

		; Add it

		call Warp_In		; Warp it in

		; Exit

		ret			; Done

; Move a bomber

MBR_Shot:	mov ax,Bomber_Score	; Score
		call Add_Score		;

		jmp MT_Shot		; Vector off

Move_Bomber:	test b cs:dFlags[di],080h; Hit ?
		jnz MBR_Shot		 ; Yes, skip

		; Drop bomb ?

		dec w cs:dLife[di]	; Time to bomb ?
		jz MB_Bomb		; Yes, skip
		
		; Change colour

MB_NoBomb:	mov al,cs:Frame_Cnt	; Incs at 60Hz
		mov ah,al		; Save

		mov cl,3		; /8
		ror al,cl		;

		and al,02h		; 0/2
		add al,0Bh		; 

		mov bl,al		; This
		xor al,02h		; Other
		mov bh,al		;

		mov cs:dCol2[di],bx	; Store colour

		mov cs:dMap_Col[di],bl	; Flashing

		; Move it in X

		mov al,cs:ddX[di]	; Velocity
		cbw			; 16-bit
		add ax,cs:d_X[di]	; Step it

		call Wrap_X		; Clip it

		mov cs:d_X[di],ax	; Save new X

		; Move it in Y

		mov al,cs:d_Y[di]	; Posn
		mov ah,cs:ddY[di]	; Dirn

		cmp al,(200-Top_Y)/2 + Top_Y ; Above/below middle ?
		jae MBR_Y_1		     ; Above

		add ah,2		; +1

MBR_Y_1:	dec ah			; -1

		mov cs:ddY[di],ah	; Save dirn

		sar ah,1		; /4
		sar ah,1		;
		sar ah,1		;

		add al,ah		; Move

		mov cs:d_Y[di],al	; Store it

		; Save the clipping Y's

		add al,4		; Bottom
		mov cs:dBott[di],al	;

		sub al,4+4		; Top
		mov cs:dTop[di],al	;

		; Draw it, etc

		jmp MT_Show		; Show it

vMB_NoBomb:	jmp s MB_NoBomb		; Vector

	; Drop a bomb

MB_Bomb:	mov al,cs:optBomb_Rate	; Reset Cnt
		mov ah,0		;
		mov cs:dLife[di],ax	;

		; Are we allowed any ?

		mov ax,cs:Bomb_Count	; How many left ?
		mov bl,cs:optBomb_Cnt	;
		mov bh,0		;
		cmp ax,bx		;
		je vMB_NoBomb		; None, skip

		inc ax			; One more
		mov cs:Bomb_Count,ax	; Store cnt

		; Drop one

		push di			; Save
		mov si,di		;

		call Get_Free		; Find a free space
		jc MBB_X		; Can't, exit

		; Setup speed

		mov b cs:dSpeed[di],1	; Every frame
		mov b cs:dDelay[di],1	;

		; Set it to the bombers's position

		; X

		mov ax,cs:d_X[si]	; X
		mov cs:d_X[di],ax	;

		; Y

		mov al,cs:d_Y[si]	; Y
		mov cs:d_Y[di],al	;

		; Save the clipping Y's

		add al,3		; Bottom
		mov cs:dBott[di],al	;

		sub al,3+3		; Top
		mov cs:dTop[di],al	;

		; Shape

		mov b cs:dShape[di],22	; Bomb shape
		mov b cs:dTemp1[di],1	; Change count

		; Setup colours

		mov ax,0B0Fh		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0309h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],White ; Map

		; Setup life

		mov ax,cs:Bomb_Life	; Time
		mov cs:dLife[di],ax	;

		; Setup it's move routine

		mov w cs:dpMove[di],o Move_Bomb ; Move routine

		; Setup it's shot routine

		mov w cs:dpShot[di],o Thing_Shot; Normal
		mov b cs:dHits[di],Bomb_Hits	; Lots !

		; Set its flags

		mov b cs:dFlags[di],0	; It's alive

		; Clear the map data

		mov w cs:dMap_Ptr[di],0	; Nothing

		; Add it to the list

		call Add_Thing		; Add it to the list

		; Done, exit

MBB_X:		pop di			; Restore ptr

		; Move bomber

		jmp MB_NoBomb		; Show it

; Bomb dead

vMB_Shot:	jmp MB_Shot		; Vector

; Move a bomb

Move_Bomb:	test b cs:dFlags[di],080h; Hit ?
		jnz vMB_Shot		 ; Yes, skip

		; Have we hit the ship ?

		mov al,cs:Ship_Y	; The ship's Y
		sub al,3		; Widen it
		cmp al,cs:dBott[di]	; Get the highest possible Y
		jb MB_PossHit		; Yes, possible hit

		; Dec life

MB_NotHit:	dec w cs:dLife[di]	; Dead yet ?
		jz MB_TO		; Assume shot

		; Change shape

		dec b cs:dTemp1[di]	; Shape count
		jnz MB_Show		; Not yet

		mov b cs:dTemp1[di],10	; Rate

		xor b cs:dShape[di],1	; Flip the shape

		; Draw it, etc

MB_Show:	jmp MT_Show		; Show it

	; Possible impact with the ship

MB_PossHit:	add al,3+3		; Down
		cmp al,cs:dTop[di]	; Get the highest possible Y
		jb MB_NotHit		; No, not hit

		; The Y's are right, check the X's

		mov ax,cs:Ship_X	; The ship's position

		sub ax,16		; Back 11
		call Wrap_X		;
		mov cx,ax		;

		mov ax,cs:Ship_X	; The ship's position

		add ax,16		; Back 11
		call Wrap_X		;
		mov dx,ax		;

		mov ax,cs:d_X[di]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc MBPH_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb MB_NotHit		; No, fail

		cmp ax,dx		; X in range ?
		ja MB_NotHit		; No, fail

		; Assume a hit

		mov al,Bomb_Damage	; Dec the shields
		call Shield_Dec		;

		; Explode the mine

MB_Hit:		jmp MB_Shot		; Assume dead

	; The bomb is at the end, alternate clip

MBPH_CheckEnd:	cmp ax,dx		; X<RHS
		jb MB_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja MB_Hit		; Yes, skip 

		; Not hit, skip

		jmp s MB_NotHit		; Skip

	; Timed-out

MB_TO:		mov w cs:dpMove[di],o Bomb_Fall ; Drop

		; Clear velocity

		mov b cs:ddY[di],0	; Start small
		mov b cs:dTemp2[di],0	; Extra bits

		; Change colours

		mov ax,0305h		; Col 0,1
		mov cs:dCol1[di],ax	;

		mov ax,0901h		; Col 2,3
		mov cs:dCol2[di],ax	;

		mov b cs:dMap_Col[di],Cyan ; Colour in map

		; Lower hit-points

		mov b cs:dHits[di],1	; Only one

		; Done

		jmp MT_Show		; Show it

	; Bomb dead

MB_Shot:	dec w cs:Bomb_Count	; One more bomb

		jmp MT_Shot		; Vector

	; Bomb falling

Bomb_Fall:	test b cs:dFlags[di],080h; Hit ?
		jnz MB_Shot		 ; Yes, skip

		; Calc new dY

		inc b cs:ddY[di]	; Fall faster

		; Y

		mov ch,cs:d_Y[di]	; Y

		mov al,cs:ddY[di]	; Move it
		mov ah,0		; 16-bit

		mov cl,3		; * 32
		shl ax,cl		;

		mov cl,cs:dTemp2[di]	; Low bits
		add cx,ax		; Move

		mov cs:d_Y[di],ch	; Save
		mov cs:dTemp2[di],cl	;

		; Save the clipping Y's

		mov al,ch		; Get Y

		add al,3		; Bottom
		mov cs:dBott[di],al	;

		sub al,3+3		; Top
		mov cs:dTop[di],al	;

		; Now, is this below the ground ?

		mov ax,cs:d_X[di]	; Save new X

		; Get its Y

		mov bx,o Mount_Ys	; Y defn
		add bx,ax		;

		mov ax,DATA		; Get the seg
		mov ds,ax		;

		mov al,ds:[bx]		; Get the Y
		sub al,3

		; Is this below the bomb ?

		cmp al,ch		; Y < Mount ?
		jb BF_Landed		; No, explode it
		
		; Draw it, etc

		jmp MT_Show		; Show it

	; The bomb has fallen, is there a man near it ?

BF_Landed:	mov bl,ch		; Save the Y

		mov ax,cs:d_X[di]	; Get the X
		mov dx,ax		; Save it

		sub ax,Bomb_Spread	; Back 11 pels

		call Wrap_X		; Clip X

		mov cx,ax		; Save the LHS

		mov ax,dx		; Get the X
		add ax,Bomb_Spread	; Forward 11 pels

		call Wrap_X		; Clip X

		mov dx,ax		; Save the RHS

		; Search for impacts

		call BF_Search		; Look for impacts

		; Kill the bomb, anyway

		dec w cs:Bomb_Count	; One more free

		; Explode

		mov ax,cs:d_X[di]	; X
		mov dl,cs:d_Y[di]	; Y

		mov bx,o Frag_Explode_B	; Ptr to table
		call Gen_Frag		; Generate the fragments

		; No score

		stc			; Kill it
		ret			; Done

; Search to see if we have killed a man

BF_Search:	mov si,cs:pThings	; Point at the creatures

		jmp s BFS_Lp1		; Enter the loop

	; Try the next one

BFS_Lp:		mov si,cs:dpNext[si]	; Point at the next one

BFS_Lp1:	cmp si,0		; End ?
		je BFS_X		; Yes, done

		; Is this a man ?

		cmp w cs:dpMove[si],o Move_Man	; Is it a man ?
		jne BFS_Lp			; No, loop

		; Now try the X's

		mov ax,cs:d_X[si]	; X in range ?

		cmp cx,dx		; Wrapped ?
		jnc BFS_CheckEnd	; Yes, try another clip

		; Now try the X's

		cmp ax,cx		;
		jb BFS_Lp		; No, fail

		cmp ax,dx		; X in range ?
		ja BFS_Lp		; No, fail

		; Try the Y's

		cmp cs:dTop[si],bl	; Y in range ?
		jae BFS_Lp		; No, loop

		cmp cs:dBott[si],bl	; Y in range ?
		jb BFS_Lp		; No, loop

		; A hit, a palpable hit

BFS_Hit:	or b cs:dFlags[si],80h	; Assert killed

		; See if any more

		jmp s BFS_Lp		; Loop

	; The bomb is at the end, alternate clip

BFS_CheckEnd:	cmp ax,dx		; X<RHS
		jb BFS_Hit		; Yes, skip

		cmp ax,cx		; LHS<X
		ja BFS_Hit		; Yes, skip 

		; Loop

		jmp s BFS_Lp		; Loop

	; Done, exit

BFS_X:		ret			; Done

; Vars here

Bomb_Count	dw ?			; This many
