; This is the monster driving source

; Offsets, used for all things

nSpace		equ 220			; This many

dpNext		equ 0;1			; Ptr to the next item

dFlags		equ 2			; 1 = Alive

	; The order of these is important !!

d_frac_Y	equ 3			; fractional Y
d_Y		equ 4			; Y pos

d_frac_X	equ 5			; fractional X
d_X		equ 6;7			; X pos

	; Not any more

dpMove		equ 8;9			; Ptr to move routine

ddX		equ 10;11		; dX
ddY		equ 12;13		; dY

dSpeed		equ 14			; Movement rate
dDelay		equ 15			; Time to shape change

dState		equ 16			; What we are doing . . .
dCnt		equ 17			; Shape counter

dShape		equ 18			; The sprite number
dHits		equ 19			; The number of hits

dCol1		equ 20;21		; Colours
dCol2		equ 22;23		;

dfTab		equ 24;25		; Ptr to fragment table

dLife		equ 26;27		; It's life-time in frames

dTop		equ 28			; Clipping Y's
dBott		equ 29			;

dMap_Ptr	equ 30;31		;
dMap_Col	equ 32			;

dTemp1		equ 33			; Used by crazy man, and baiter, lander
dpShot		equ 34;35		; Shot by the man

dTargdX		equ 36;37		; Target dX
dTargdY		equ 38;39		; Target dY
dTargSpeed	equ 40;41		; Speed

dpPad		equ 42;43		; Point at the target pad, used by lander

dTemp2		equ 44			;

lSpace		equ 46			; Length of data

; Create the free-space table

Init_Free:	mov di,o Free_Space	; Clear the memory

		mov cx,lSpace*nSpace	; This much RAM

		mov al,0		; Clear to 00

		push es			; Save

		push cs			; In cs
		pop es			;

		rep stosb		; Clear it all

		pop es			; Restore

		; Now fragment it

		mov si,o Free_Space	; Set up the list

		mov cs:pFree,si		; Point at the first block

		mov cx,nSpace-1		; This much

IF_Lp:		lea bx,lSpace[si]	; Point at the next block

		mov cs:dpNext[si],bx	; Link to it

		mov si,bx		; Point at the next

		loop IF_Lp		; Loop

		; Kill the last block

		mov w cs:dpNext[bx],0	; Kill the last block

		; Done

		ret			; Done

; Init the things

Init_Things:	mov w cs:pThings,0	; Kill the list
		ret			; Done

; Init the laser

Init_Lasers:	mov w cs:pLasers,0	; Kill the list
		ret			; Done

; Init the projectiles

Init_Projs:	mov w cs:pProjs,0	; Kill the list
		ret			; Done

; Init the fragments

Init_Frags:	mov w cs:pFrags,0	; Kill the list
		ret			; Done

; Get a free block

Get_Free:	mov di,cs:pFree		; Get a block

		cmp di,0		; NZ = ok
		jz GF_Fail		; Fail, none

		push ax			; Save

		mov ax,cs:dpNext[di]	; Point at the next one
		mov cs:pFree,ax		; Setup the ptr

		pop ax			; Restore

		clc			; Ok
		ret			;

GF_Fail:	stc			; Fail
		ret			; Done

; Release a block

Put_Free:	push ax			; Save

		mov ax,cs:pFree		; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pFree,di		; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a thing

Add_Thing:	push ax			; Save

		mov ax,cs:pThings	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pThings,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a laser bolt

Add_Laser:	push ax			; Save

		mov ax,cs:pLasers	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pLasers,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a proj

Add_Proj:	push ax			; Save

		mov ax,cs:pProjs	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pProjs,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Add a fragment

Add_Frag:	push ax			; Save

		mov ax,cs:pFrags	; The first in the list

		mov cs:dpNext[di],ax	; Link it

		mov cs:pFrags,di	; Point at the list

		pop ax			; Restore
		ret			; Done

; Variables
		align 2			; Word aligned

pFree		dw 0			; Ptr to free space

pThings		dw 0			; Ptr to monsters

pLasers		dw 0			; Ptr to laser bolts

pProjs		dw 0			; Ptr to projectiles

pFrags		dw 0			; Ptr to explosion fragments

Free_Space	db lSpace * nSpace dup (?) ; Some room for things
Free_End	equ this byte		   ; Endit
